class PowerUp expands Mutator config (MH_OsPower2);

var bool bMustDestruct, bEnabled, bIsOld;
var class<Inventory> PowerClass;
var Inventory I;
var config int SpawnRate;
var Pawn aPlayer;
var float Appearance;

event PostBeginPlay()
{
	local MonsterHunt MH;

	log (Self.class@"Relic-Type Mutator attempt to start...");
	if ( SpawnRate < 30 ) //Is somehow stupid such value
	{
		log (Self.class@"warning: SpawnRate must be at least 30 seconds, value"@SpawnRate@"has been adjusted.");
		SpawnRate=30;
	}
	if (SpawnRate > 600) //I don't think is interesting if a map is already ended
	{
		log (Self.class@"warning: SpawnRate must be under 600 seconds, value"@SpawnRate@"has been adjusted.");
		SpawnRate=600;
	}
	SaveConfig();
	Appearance=1/Level.TimeDilation*SpawnRate; //Setting timer value
//	log ("Appearance of"@Self.class@"is"@Appearance);
	MH = MonsterHunt(Level.Game);
	if (MH == None)
	{
		log (Self$" >> Presuming MonsterHunt is not original, mutator won't work...");
		bMustDestruct=True;
//		SetTimer (Appearance,False);
	}
	else
	{
		log (Self.class$" checking for availability...");
		if (MH.DefaultWeapon == class'DispersionPistol')
		{
			bIsOld=True;
			PowerClass=class'UnrealShare.WeaponPowerUp';
			log (Self.class@"will deal in original style...");
//			SetTimer (Appearance, True);
		}
		else if (MH.DefaultWeapon == class'OLDPistol')
		{
			bIsOld=False;
			PowerClass = class'MH_OsPower2.osWeaponPowerup';
			log (Self.class@"will deal in replacement style...");
//			SetTimer (Appearance, True);
		}
		else
		{
			log ("Default weapon for this MonsterHunt configuration is pointless for such Mutator, will self destruct soon...");
			bMustDestruct = True;
//			SetTimer (Appearance,False);
		}
	}
}

function DoTickRelic()
{
	if (!ValidCheck())
		bMustDestruct=True;
	if ( bMustDestruct )
	{
		BroadcastMessage ("PowerUp Mutator Perform Self Removal. Bad Environment Detected.");
		Destroy();
		return;
	}
	else
	{
		CheckForPlayers();
		if ( aPlayer != None )
			DoSpawnPower(aPlayer);
	}
}

function bool ValidCheck()
{
	local int NumNodes;
	local NavigationPoint N;
	local bool bResult, bSmaller;

	NumNodes=0; //Is 0 anyway

	bResult = True;
	if (aPlayer != None)
	{
		for ( N = Level.NavigationPointList; N != None; N = N.NextNavigationPoint )
		{
			if ( N.IsA('PathNode') )
			{
				if ( Vsize(N.Location-aPlayer.Location) <= 5000 && !bSmaller)
					bSmaller=True;
				NumNodes++;
			}
		}
		if ( NumNodes < 10 )
			bResult = False;
		bResult = bSmaller;
	}
	return bResult;
}

function CheckForPlayers()
{
	local Pawn N, Dest, Candidate[32];
	local int num, Chosen;
	local osWeaponPowerup Op;
	local WeaponPowerup Old;
	local bool bSkipRate;

	num = 0;
	Chosen = 0;

	for (N=Level.PawnList; N!=None; N=N.NextPawn)
	{
		if ( N != None )
		{
			if (  N.bIsPlayer && N.PlayerReplicationInfo != None && N.Health > 0 && N.Weapon != None && N.PlayerReplicationInfo.Team == 0 ) //Any kinda Spectator I'm guessing does not has weapons in end...
			{
				Dest = N; //Assign a Pawn
				if ( num < 32 ) //Must be in list with players.
					Candidate[num] = Dest; //Add to array.
				Dest = None; //Array loaded, release slot...
				num++; //Increase array count for next possible player
			}
		}
	}
	if(num == 0) aPlayer = None; //None if 0 people are playing
	else
	{
		Chosen = Rand(num); //Get a random 
		aPlayer=Candidate[Chosen]; //And Simply return that Random
//		log ("Player closer seems "$aPlayer.GetHumanName());
	}
}

function DoSpawnPower(Pawn aPlayer)
{
	local Pathnode Pt;
	local NavigationPoint NP;
	local Rotator DropRot;

//	log ("Start finding NavigationPoints available.");
/*	for (NP = Level.NavigationPointList; NP != None; NP = NP.NextNavigationPoint)
	{
		if ( NP.IsA('PathNode') && FastTrace(aPlayer.Location,NP.Location))
		if ( NP.PlayerCanSeeMe())

	}
*/
	foreach RadiusActors (class'PathNode',Pt,1650,aPlayer.Location)
	{
		if ( Pt != None && Pt.PlayerCanSeeMe() )
		{
//			log ("WantSpawn at "$Pt.Location);
			I = Spawn(PowerClass,,,Pt.Location);
			if (I != None)
			{
				I.RespawnTime = 0;
				I.LifeSpan=Appearance*0.9;
				I.RemoteRole = ROLE_DumbProxy;
				I.bCollideWorld = True;
				DropRot = Pt.Rotation;
				DropRot.Pitch = Rand(32768);
				DropRot.Yaw = Rand(65536);
				I.Velocity = vector(DropRot) * RandRange(250,301);
				I.Velocity.Z = RandRange(250,451);
				I.SetPhysics(PHYS_Falling);
				I.GotoState('Pickup', 'Dropped');
				spawn(class'OsReSpawn',,,I.Location );
//				log (I$" spawned at "$I.Location);
				break;
			}
		}
	}
	I = None;
}

function bool HandlePickupQuery(Pawn Other, Inventory item, out byte bAllowPickup)
{
	local bool result;
	local Inventory I, I1;

	if (aPlayer != None && Other != None)
	if ( Item.class == class'MH_OsPower2.OsWeaponPowerup' || Item.class == class'WeaponPowerup')
	{
		I = Other.FindInventoryType(class'DispersionPistol');
		I1 = Other.FindInventoryType(class'OLDPistol');
		if ( I != None && DispersionPistol(I).PowerLevel < 4 )
			DispersionPistol(I).Ammotype.AmmoAmount+=500;
		if ( I1 != None && OLDPistol(I1).PowerLevel < 4 )
			OLDPistol(I1).Ammotype.AmmoAmount+=500;
	}
	if ( NextMutator != None )
		result = NextMutator.HandlePickupQuery(Other, item, bAllowPickup);
	return result;
}

Auto State RatePowering
{
Begin:
	Sleep(7.00);
TickTock:
	if (!bMustDestruct)
		DoTickRelic();
	Sleep(Appearance);
	Goto('TickTock');
}

defaultproperties
{
   SpawnRate=100
}